"gam.sim"<-
  function(gam.data, start, prev.sims = NULL)
{
  if(is.null(prev.sims)) {
    prev.sims <- list(m = 0, tval = NULL, tvalobs = start$tvalobs, 
                      pval = NULL, sigmat = matrix(0, nrow = length(start$
                                                        surf.est[, 1]), ncol = length(start$surf.est[1,  ])), x
                      = start$x, y = start$y)
  }
  null.prob <- start$prob
  surface.est <- start$surf.est
  h <- start$h
  why <- gam.data$why
  simcase <- sample(1:length(why), size = sum(why), replace = F, prob = 
                    null.prob)
  simwhy <- rep(0, length(why))
  simwhy[simcase] <- 1
  gam.data$why <- simwhy
  sim <- gamfit(gam.data, h= start$h, ngrid = start$ngrid)
  tval <- mean(sim$g2^2)
  below <- as.numeric(sim$g2est$z < surface.est)
  prev.sims$m <- prev.sims$m + 1
  prev.sims$tval <- c(prev.sims$tval, tval)
  prev.sims$sigmat <- prev.sims$sigmat + below
  prev.sims$pval <- (sum(prev.sims$tval >= start$tvalobs) + 1)/(prev.sims$
                           m + 1)
  cat("\n\n ********* DONE", prev.sims$m, "GAM FITS *********\n\n")
  prev.sims
}
