"kernelw.sil"<-
function(data, t, poly, h, ngrid = 1000, kernel = "normal", weights= rep(1,length(t)), obsize = 5000000)
{
# This function prodices similar results as kernel.sil
# here you can apply different weights to each t

	.h <- h
	.poly <- poly
	.obsize <- obsize
	.kernel <- kernel
	options(object.size = .obsize)
	xrange <- range(.poly[, 1])
	yrange <- range(.poly[, 2])
	xmin <- xrange[1]
	xmax <- xrange[2]
	ymin <- yrange[1]
	ymax <- yrange[2]
	xlength <- diff(xrange)
	ylength <- diff(yrange)
	actngrid <- (ngrid * xlength * ylength)/(area(.poly))
	.nx <- ceiling(sqrt((actngrid * xlength)/ylength))
	.ny <- ceiling(sqrt((actngrid * ylength)/xlength))
	ans <- list(0, 0, 0, 0)
	names(ans) <- c("x", "y", "z", "poly")
	ans$poly <- .poly
	.nx <<- .nx
	.ny <<- .ny
	.n <<- npts(data)
	.data <<- data
	.h <<- h
	.t <<- t
	ker <- kdebig(.h, data, .t, poly = .poly, kernel = .kernel, nx = .nx, 
		ny = .ny, edge = F, scale = F)
	.x <<- ker$x
	.y <<- ker$y
	ans$x <- .x
	ans$y <- .y
	.poly <<- .poly
	.kernel <<- .kernel
	.obsize <<- .obsize
	ker <- kdebigw(.h, data, .t, poly = .poly, kernel = .kernel, x = .x, y
		 = .y, w=weights, edge = F, scale = F)
	rm(.nx, .ny, .x, .y, .obsize, .n, .poly, .kernel, .h)
	ans$z <- ker$z
	cat("\n")
	ans
}
