

  create.gamdata <- function(cancer,adult=T) {
    tmp.ca        <- cadat.n[((cadat.n$site==cancer)&(cadat.n$ageband>3)),c(3,4,16,13,14)]
    names(tmp.ca) <- c("age","sex","townindx","gridE","gridN")
    tmp.co        <- coadult.n[,c(8,2,7,4,5)]
    names(tmp.co) <- c("age","sex","townindx","gridE","gridN")

    pts<-rbind(tmp.ca[,4:5],tmp.co[,4:5])
    why<-c(rep(1,nrow(tmp.ca)),rep(0,nrow(tmp.co)))
    region<-poly.n
    hvals<-50
    ny<-length(why)
    form<-'age+sex+townindx'
    age<-c(tmp.ca$age,tmp.co$age)
    sex<-c(tmp.ca$sex,tmp.co$sex)
    townindx<-c(tmp.ca$townindx,tmp.co$townindx)
    gam.data<-list(pts=pts,why=why,ny=length(why),region=region,hvals=hvals,age=age,sex=sex,townindx=townindx,form=form)
    return(gam.data)
}

gamdata.adultlung<-create.gamdata('lung')
gamdata.adultcolorect<-create.gamdata("colorectal")

 source('/home/shimakur/Fazakerley/Src/cvkreg2d.S')
 source('/home/shimakur/Fazakerley/Src/dynload.S')
 source('/home/shimakur/Fazakerley/Src/gam.sig.start.S')
 source('/home/shimakur/Fazakerley/Src/gam.sim.S')
 source('/home/shimakur/Fazakerley/Src/gamfit.S')
 source('/home/shimakur/Fazakerley/Src/gamfit.sig.S')
 source('/home/shimakur/Fazakerley/Src/hch2d.S')
 source('/home/shimakur/Fazakerley/Src/kdebigw.S')
 source('/home/shimakur/Fazakerley/Src/kernelw.sil.S')
 source('/home/shimakur/Fazakerley/Src/kerreg2d.S')
 source('/home/shimakur/Fazakerley/Src/my.plotrisk.S')
 source('/home/shimakur/Fazakerley/Src/my.polymap.S')
 source('/home/shimakur/Fazakerley/Src/plotrisk.sil.S')
 source('/home/shimakur/Fazakerley/Src/polymap.sil.S')
 source('/home/shimakur/Fazakerley/Src/saveplot.S')
 source('/home/shimakur/Fazakerley/Src/sfunspath.S')
 source('/home/shimakur/Fazakerley/Src/waddmod.S')

gamfit.adultlung<-gamfit(gamdata.adultlung,h=50,ngrid=1600)
gamfit.adultcolorect<-gamfit(gamdata.adultcolorect,h=50,ngrid=1600)



create.data2 <- function(cancer1,cancer2,adult=T) {
  if (adult) {
    tmp.ca        <- cadat.n[(((cadat.n$site==cancer1)|(cadat.n$site==cancer2))&(cadat.n$ageband>3)),c(3,4,16,13,14)]
    names(tmp.ca) <- c("age","sex","townindx","gridE","gridN")
    tmp.co        <- coadult.n[,c(8,2,7,4,5)]
    names(tmp.co) <- c("age","sex","townindx","gridE","gridN")
  } else {
    tmp.ca        <- cadat.n[(((cadat.n$site==cancer1)|(cadat.n$site==cancer2))&(cadat.n$ageband<4)),c(3,4,16,13,14)]
    names(tmp.ca) <- c("age","sex","townindx","gridE","gridN")
    tmp.co        <- cochild.n[,c(8,2,7,4,5)]
    names(tmp.co) <- c("age","sex","townindx","gridE","gridN")
  }    

  rbind(tmp.ca,tmp.co)
}


  create.samplefromcontrols <- function(cancer1,cancer2,adult=T) {
    tmp.ca        <- cadat.n[(((cadat.n$site==cancer1)|(cadat.n$site==cancer2))&(cadat.n$ageband>3)),c(3,4,16,13,14)]
    names(tmp.ca) <- c("age","sex","townindx","gridE","gridN")
    s<-sample(1:nrow(coadult.n),2000)
    tmp.co        <- coadult.n[s,c(8,2,7,4,5)]
    names(tmp.co) <- c("age","sex","townindx","gridE","gridN")

    pts<-rbind(tmp.ca[,4:5],tmp.co[,4:5])
    why<-c(rep(1,nrow(tmp.ca)),rep(0,nrow(tmp.co)))
    region<-poly.n
    hvals<-50
    ny<-length(why)
    form<-'age+sex+townindx'
    age<-c(tmp.ca$age,tmp.co$age)
    sex<-c(tmp.ca$sex,tmp.co$sex)
    townindx<-c(tmp.ca$townindx,tmp.co$townindx)
    gam.data<-list(pts=pts,why=why,ny=length(why),region=region,hvals=hvals,age=age,sex=sex,townindx=townindx,form=form)
    return(gam.data)
}

gamdata.adultleuklym<-create.samplefromcontrols('leukaemias','lymphomas')
gamfit.adultleuklym<-gamfit(gamdata.adultleuklym,h=50,ngrid=1600)

my.plotrisk(gamsig.adultleuklym)
title('Leukaemia+Lymphomas (P=0.67)')
points(Fsource,pch=17,cex=1.5)
saveplot('gamsig.adultleuklym.ps')

pl.sil<-function(){
  par(pty = "s", font = 3)
  pointmap(poly.n, type = "n", cex = 0.7)
  polymap(poly.n, add = T)
  points(Fsource,pch=17,cex=2)
}

# adult colorectal
tmp.ca     <- cadat.n[((cadat.n$site=="colorectal")&(cadat.n$ageband>3)),c(13,14
)]
site.pts.n <- as.points(tmp.ca[,1],tmp.ca[,2])
pl.sil(); points(site.pts.n,cex=0.6)
saveplot('fig2.ps')

# adult lung
tmp.ca     <- cadat.n[((cadat.n$site=="lung")&(cadat.n$ageband>3)),c(13,14)]
site.pts.n <- as.points(tmp.ca[,1],tmp.ca[,2])
pl.sil(); points(site.pts.n,cex=0.6)
saveplot('fig3.ps')

# adult liver
tmp.ca     <- cadat.n[((cadat.n$site=="liver")&(cadat.n$ageband>3)),c(13,14)]
site.pts.n <- as.points(tmp.ca[,1],tmp.ca[,2])
pl.sil(); points(site.pts.n,cex=0.6)
saveplot('fig4.ps')

 
# adult L & N
tmp.ca     <- cadat.n[(((cadat.n$site=="Larynx")|(cadat.n$site=="Nasopharynx"))&(cadat.n$ageband>3)),c(13,14)]
site.pts.n <- as.points(tmp.ca[,1],tmp.ca[,2])
pl.sil(); points(site.pts.n,cex=0.6)
saveplot('fig5.ps')

# adult L & L
tmp.ca     <- cadat.n[(((cadat.n$site=="leukaemias")|(cadat.n$site=="lymphomas"))&(cadat.n$ageband>3)),c(13,14)]
site.pts.n <- as.points(tmp.ca[,1],tmp.ca[,2])
pl.sil(); points(site.pts.n,cex=0.6)
saveplot('fig6.ps')

# adult Soft Tissiue Sarcomas
tmp.ca     <- cadat.n[((cadat.n$site=="softtissarc")&(cadat.n$ageband>3)),c(13,14)]
site.pts.n <- as.points(tmp.ca[,1],tmp.ca[,2])
pl.sil(); points(site.pts.n,cex=0.6)
saveplot('fig7.ps')

# adult controls
site.pts.n <- as.points(coadult.n[,4],coadult.n[,5])
pl.sil(); points(site.pts.n,cex=0.6)
saveplot('fig8.ps')

# childhood L & L
tmp.ca     <- cadat.n[(((cadat.n$site=="leukaemias")|(cadat.n$site=="lymphomas"))&(cadat.n$ageband<4)),c(13,14)]
site.pts.n <- as.points(tmp.ca[,1],tmp.ca[,2])
pl.sil(); points(site.pts.n,cex=0.6)
saveplot('fig9.ps')

# child controls
site.pts.n <- as.points(cochild.n[,4],cochild.n[,5])
pl.sil(); points(site.pts.n,cex=0.6)
saveplot('fig10.ps')


######GAM fits

#adult colorectal
my.plotrisk(gamsig.adultcolorect)
points(Fsource,pch=17,cex=2)
saveplot('fig11.ps')


#adult Leukaemia+Lymphomas
my.plotrisk(gamsig.adultleuklym)
points(Fsource,pch=17,cex=2)
saveplot('fig13.ps')


#adult lung
my.plotrisk(gamsig.adultlung)
points(Fsource,pch=17,cex=2)
saveplot('fig12.ps')

